// Compiled by ClojureScript 1.7.122 {:elide-asserts true}
goog.provide('wryte.speech_recognition');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('cljs.test');
wryte.speech_recognition.log = (function wryte$speech_recognition$log(x){
return console.log(x);
});
cljs.core.enable_console_print_BANG_.call(null);
wryte.speech_recognition.ignore_onend = cljs.core.atom.call(null,false);
wryte.speech_recognition.setup = (function wryte$speech_recognition$setup(onstart,onerror,onend,onresult,lang){

if(!(typeof window.webkitSpeechRecognition !== 'undefined')){
return alert("Speech recognition is not present");
} else {
var recognition = (new window.webkitSpeechRecognition());
recognition.continuous = true;

recognition.interimResults = true;

recognition.onstart = onstart;

recognition.onerror = ((function (recognition){
return (function (ev){
cljs.core.reset_BANG_.call(null,wryte.speech_recognition.ignore_onend,true);

return onerror.call(null,ev);
});})(recognition))
;

recognition.onend = ((function (recognition){
return (function (ev){
if(cljs.core.truth_(cljs.core.deref.call(null,wryte.speech_recognition.ignore_onend))){
return false;
} else {
return onend.call(null,ev);
}
});})(recognition))
;

recognition.onresult = onresult;

recognition.lang = lang;

return recognition;
}
});
/**
 * Object String -> Void
 *   Set's the given language l of the given speechRecognition sro
 */
wryte.speech_recognition.set_language_BANG_ = (function wryte$speech_recognition$set_language_BANG_(sro,l){
return sro.lang = l;
});
/**
 * String -> String
 *   Consumes a string s and produces the same string with the first word of an sentence capitlized
 */
wryte.speech_recognition.cap_sentence = (function wryte$speech_recognition$cap_sentence(s){
return clojure.string.replace.call(null,s,/[\.\?\!](\s+.|$)/,(function (x){
return clojure.string.upper_case.call(null,cljs.core.first.call(null,x));
}));
});
/**
 * String -> string
 *   Consumes a String s and produces the same string with double whitspace removed except \n.
 */
wryte.speech_recognition.colapse_double_whitespace = (function wryte$speech_recognition$colapse_double_whitespace(s){
return clojure.string.replace.call(null,s,/[\t\r ]{2,}/," ");
});
/**
 * String -> String
 *   Consumes a String s and produces the same string with the linebreaks colapsed to \n only.
 */
wryte.speech_recognition.colapse_linebreak = (function wryte$speech_recognition$colapse_linebreak(s){
return clojure.string.replace.call(null,s,/ \n|\n /,"\n");
});
/**
 * String -> String
 *   Consume a String s with newline character \n and produces a string with a new paragraph for every newline
 */
wryte.speech_recognition.newline__GT_paragraph = (function wryte$speech_recognition$newline__GT_paragraph(s){
return [cljs.core.str("<p>"),cljs.core.str(clojure.string.replace.call(null,s,/\n/,"</p><p>")),cljs.core.str("</p>")].join('');
});
try{var values__18657__auto___18810 = cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,wryte.speech_recognition.newline__GT_paragraph.call(null,"This is a test string with one paragraph.")),"<p>This is a test string with one paragraph.</p>");
var result__18658__auto___18811 = cljs.core.apply.call(null,cljs.core._EQ_,values__18657__auto___18810);
if(cljs.core.truth_(result__18658__auto___18811)){
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"pass","pass",1574159993),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),"<p>This is a test string with one paragraph.</p>",cljs.core.list(new cljs.core.Symbol(null,"newline->paragraph","newline->paragraph",-226058673,null),"This is a test string with one paragraph.")),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core.cons.call(null,cljs.core._EQ_,values__18657__auto___18810),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
} else {
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"fail","fail",1706214930),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),"<p>This is a test string with one paragraph.</p>",cljs.core.list(new cljs.core.Symbol(null,"newline->paragraph","newline->paragraph",-226058673,null),"This is a test string with one paragraph.")),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,cljs.core.cons.call(null,new cljs.core.Symbol(null,"=","=",-1501502141,null),values__18657__auto___18810)),new cljs.core.Symbol(null,"not","not",1044554643,null)),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}

}catch (e18809){var t__18695__auto___18812 = e18809;
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),"<p>This is a test string with one paragraph.</p>",cljs.core.list(new cljs.core.Symbol(null,"newline->paragraph","newline->paragraph",-226058673,null),"This is a test string with one paragraph.")),new cljs.core.Keyword(null,"actual","actual",107306363),t__18695__auto___18812,new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}try{var values__18657__auto___18814 = cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,wryte.speech_recognition.newline__GT_paragraph.call(null,"This is a test string with\ntwo paragraphs.")),"<p>This is a test string with</p><p>two paragraphs.</p>");
var result__18658__auto___18815 = cljs.core.apply.call(null,cljs.core._EQ_,values__18657__auto___18814);
if(cljs.core.truth_(result__18658__auto___18815)){
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"pass","pass",1574159993),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),"<p>This is a test string with</p><p>two paragraphs.</p>",cljs.core.list(new cljs.core.Symbol(null,"newline->paragraph","newline->paragraph",-226058673,null),"This is a test string with\ntwo paragraphs.")),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core.cons.call(null,cljs.core._EQ_,values__18657__auto___18814),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
} else {
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"fail","fail",1706214930),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),"<p>This is a test string with</p><p>two paragraphs.</p>",cljs.core.list(new cljs.core.Symbol(null,"newline->paragraph","newline->paragraph",-226058673,null),"This is a test string with\ntwo paragraphs.")),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,cljs.core.cons.call(null,new cljs.core.Symbol(null,"=","=",-1501502141,null),values__18657__auto___18814)),new cljs.core.Symbol(null,"not","not",1044554643,null)),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}

}catch (e18813){var t__18695__auto___18816 = e18813;
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),"<p>This is a test string with</p><p>two paragraphs.</p>",cljs.core.list(new cljs.core.Symbol(null,"newline->paragraph","newline->paragraph",-226058673,null),"This is a test string with\ntwo paragraphs.")),new cljs.core.Keyword(null,"actual","actual",107306363),t__18695__auto___18816,new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}wryte.speech_recognition.sanitize = (function wryte$speech_recognition$sanitize(s){

new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [s], null);

return wryte.speech_recognition.colapse_linebreak.call(null,wryte.speech_recognition.colapse_double_whitespace.call(null,wryte.speech_recognition.cap_sentence.call(null,s)));
});
cljs.core.println.call(null,wryte.speech_recognition.cap_sentence.call(null,"right sentence. rigth sentence! right Sentence?"));
cljs.core.println.call(null,wryte.speech_recognition.cap_sentence.call(null,"Mal sehen was jetzt so passiert. das jetzt einfach anders ist was ich jetzt nicht verstehe ist wieso jetzt nicht mehr ersatz punkt punkt punkt punkt"));
/**
 * Object -> Void
 *   Consumes a webspeech object, stops the speech-recognition
 */
wryte.speech_recognition.stop_webspeech = (function wryte$speech_recognition$stop_webspeech(ws){
return ws.stop();
});
/**
 * Object -> Void
 *   Consumes a webspeech object, starts the speech-recognition
 */
wryte.speech_recognition.start_webspeech = (function wryte$speech_recognition$start_webspeech(ws){
return ws.start();
});

//# sourceMappingURL=speech_recognition.js.map